
proc Set_V879_Options {} {
    global Options V879_Base

    load_Options

   if {![info exists Options(v879.channels)]} {set Options(v879.channels) 4096}
   if {![info exists Options(v879.offset)]} {set Options(v879.offset) 0}
   if {![info exists Options(v879.shift)]} {set Options(v879.shift) 0}
   if {![info exists Options(v879_GroupBase)]} {set Options(v879_GroupBase) $V879_Base}
   set V879_Base   $Options(v879_GroupBase)

    update_Options
}

proc Dump_Raw_VME_Data_V879 {} {
    global CAEN_ModuleIndex

   set data ""

   set maxmodule [inform vmecontrol inquire v879count]
   if {[string length $maxmodule] > 2} {set maxmodule 0}
   for {set i 1} {$i <= $maxmodule} {incr i} {
      append data "V879#$i\n"
      execute-command 19 "Getting Raw Data for V879#$i" "1 $CAEN_ModuleIndex" 2
      append data [read-register EXEC.Response]
      incr CAEN_ModuleIndex
      append data "\n"
   }
   return $data
}

proc define_V879_config {} {
   global VMEserver
    global V879_Base

   set maxmodule [inform vmecontrol inquire v879count]
   if {[string length $maxmodule] > 2} {set maxmodule 0}
   if {$maxmodule > 0} then {DefineConfig "879 0 [format "0x%x" $V879_Base]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {eg "(register :name '/$VMEserver/v879#$i.Output_Buffer'  ?object)" } m]
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to locate register v879#$i.Output_Buffer"
          clear-footer
          error $m
      }
      DefineConfig "879 $i [string range [first $m] 2 end]"
   }
}

proc create_V879_spectra {} {
    global SpectrumServer V879_Base
    global Options

   set maxmodule [inform vmecontrol inquire v879count]
   if {[string length $maxmodule] > 2} {set maxmodule 0}
   set maxadc 32

   for {set i 1} {$i <= $maxmodule} {incr i} {

    set-footer "creating spectra for module v879#$i"

    for {set j 0} {$j < $maxadc} {incr j} {

      set spectrumname [SpectrumName v879#$i.adc$j]
      set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $Options(v879.channels) :name '$spectrumname' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
      if {$z!=0 && $m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum  v879#$i.adc$j"
          clear-footer
          error $m
      } else {
          set group [expr $V792_Base - 1 + $i]
          map_spectrum  "$spectrumname $group $j $Options(v879.offset) $Options(v879.shift)"
      }
    }
   }
}
